use axum::{
    Router,
    body::Bytes,
    extract::{
        State,
        Json,
        rejection::JsonRejection,
    },
};

use crate::message::Message;
use crate::db::AppState;

pub struct App {
    pub db: AppState,
    pub router: Router<AppState>,
}

impl App {
    pub fn new() -> Self {
        let db = AppState::new();    
        let router: Router<AppState> = Router::new();

        Self {
            db,
            router,
        }
    }
    
    pub async fn echo(body: Bytes) -> Bytes {
        body
    }

    pub async fn create_player(
        State(db): State<AppState>,
        json_body: Result<Json<Message>, JsonRejection>,
    )
    {
        match json_body {
            Ok(Json(message)) => {
                println!("{:?}", message);
            }
            Err(e) => eprintln!("{e}"),
        }
    }
}
